/*
 * ICFP 2002 Programming Contest
 * Entry by Seth Bruder
 *
 */

package sethbruder.icfp2002.entry;

import java.util.HashMap;
import java.util.Map;

public final class PackageInfo {

	// Map from packageId (Integer) to PackageInfo

	private static final Map allPackages = new HashMap();

	public final int id;
	public int x;
	public int y;
	public int weight;

	private PackageInfo(int id, int x, int y, int weight) {
		this.id = id;
		this.x = x;
		this.y = y;
		this.weight = weight;
	}

	public static PackageInfo get(int id) {
		PackageInfo rv = (PackageInfo)allPackages.get(new Integer(id));
		if (rv == null) {
			rv = new PackageInfo(id, -1, -1, 0);
			allPackages.put(new Integer(id), rv);
		}
		return rv;
	}

	public static PackageInfo get(int id, int x, int y, int weight) {

		PackageInfo rv = (PackageInfo)allPackages.get(new Integer(id));
		if (rv == null) {
			rv = new PackageInfo(id, x, y, weight);
			allPackages.put(new Integer(id), rv);
		}
		else { // if (rv.x == -1) {
			rv.x = x;
			rv.y = y;
			rv.weight = weight;
		}
		return rv;
	}

	public String toString() {
		return ("id=" + id + " x=" + x + " y=" + y + " w=" + weight);
	}
}
