/*
 * ICFP 2002 Programming Contest
 * Entry by Seth Bruder
 *
 */

package sethbruder.icfp2002.entry;

import java.util.LinkedList;
import java.util.StringTokenizer;
import java.util.HashSet;
import java.util.Set;
import java.util.HashMap;
import java.util.Map;


public final class TurnOutcome {

	// Map from playerIds (Integer) to PlayerMoveOutcome
	public final Map playerMoveOutcomes;

	// Set of PackageInfo
	public final Set packagesHere;

	public TurnOutcome(String moveOutcomesString, String packagesString)
		throws Exception {

		this.playerMoveOutcomes = new HashMap();
		this.packagesHere = new HashSet();

		LinkedList l;
		StringTokenizer st;
		PlayerMoveOutcome pmo;
		PackageInfo pi;

		st = new StringTokenizer(moveOutcomesString, "#", false);
		while (st.hasMoreTokens()) {
			pmo =  new PlayerMoveOutcome(st.nextToken());
			playerMoveOutcomes.put(new Integer(pmo.playerId), pmo);
		}

		st = new StringTokenizer(packagesString, " ", false);
		l = new LinkedList();
		while (st.hasMoreTokens()) {
			l.add(Integer.valueOf(st.nextToken()));
		}
		Integer[] ints = (Integer[])l.toArray(new Integer[0]);

		for (int i = 0; i < (ints.length / 4); i++) {
			pi = PackageInfo.get(ints[i * 4].intValue(),
								 ints[(i * 4) + 1].intValue(),
								 ints[(i * 4) + 2].intValue(),
								 ints[(i * 4) + 3].intValue());
			packagesHere.add(pi);
		}
	}

	public String toString() {

		StringBuffer sb = new StringBuffer();

		sb.append("   Player move outcomes: [");

		Map.Entry[] entries = (Map.Entry[])playerMoveOutcomes
			.entrySet().toArray(new Map.Entry[0]);

		for (int i = 0; i < entries.length; i++) {
			if (i > 0) sb.append(", ");
			sb.append("[" + entries[i].getValue() + "]");
		}
		sb.append("]\n");

		sb.append("   Packages on this spot: [");

		PackageInfo[] pis = (PackageInfo[])packagesHere
			.toArray(new PackageInfo[0]);

		for (int i = 0; i < pis.length; i++) {
			if (i > 0) sb.append(", ");
			sb.append(pis[i].toString());
		}
		sb.append("]\n");

		return sb.toString();
	}
}
